local MAX_SHAKE_T = 0.2
local signal = require('lib.signal')

local time = 0
local cam = {
  x = 0, y = 0, -- position
  shake_x = 0, shake_y = 0, shake_t = 0, shake_angle = 0
}

local nn = 0;
local function _r(n)
  nn = nn + 1
  return
    -- love.math.random() * n - n/2
    love.math.noise(time * 100 + nn) * n - n/2

end

function cam.reset()
  cam.x, cam.y, cma.shake_x, cma.shake_y, cma.shake_t = 0, 0, 0, 0, 0
end

function cam.shake(val)
  cam.shake_t = cam.shake_t + val
end

function cam.setup()
  signal.register('stomp', function() cam.shake(0.2) end)
  signal.register('explosion', function() cam.shake(0.4) end)
  signal.register('tile_intro', function() cam.shake(0.2) end)
  signal.register('player_intro_fall', function() cam.shake(0.2) end)
end

function cam.getXY()
  return
    cam.x + cam.shake_x,
    cam.y + cam.shake_y
end

function cam.getAngle()
  return cam.shake_angle
end


function cam.update(dt)
  time = time + dt
  cam.shake_t = cam.shake_t - dt

  if cam.shake_t > MAX_SHAKE_T then cam.shake_t = MAX_SHAKE_T end
  if cam.shake_t < 0 then cam.shake_t = 0 end

  if cam.shake_t > 0 then
    local sh_t = math.min(cam.shake_t, 2)
    cam.shake_x = _r(16) * sh_t * 8
    cam.shake_y = _r(16) * sh_t * 8
    cam.shake_angle = _r(0.02)
  else
    cam.shake_x, cam.shake_y, cam.shake_angle = 0, 0, 0
  end

end

function cam.push()
  love.graphics.push()
  local w, h = love.graphics.getDimensions()
  love.graphics.translate(w/2, h/2)
  love.graphics.rotate(cam.getAngle())
  love.graphics.translate(-w/2, -h/2)
  love.graphics.translate(cam.getXY())
end

function cam.pop()
  love.graphics.pop()
end

return cam
