local m = {}
m.serialize = function(el)
  local out = {}

  if type(el) == 'number' then
    out[#out+1] = el

  elseif type(el) == 'boolean' then
    out[#out+1] = '"'
    out[#out+1] = tostring(el)
    out[#out+1] = '"'

  elseif type(el) == 'string' then
    out[#out+1] = string.format('%q', el)

  elseif type(el) == 'table' then
    out[#out+1] = '{'
    for k, v in pairs(el) do
      out[#out+1] = k -- only supports strings
      out[#out+1] = '='
      out[#out+1] = m.serialize(v)
      out[#out+1] = ','
    end
    out[#out+1] = '}'
  end

  return table.concat(out, '')
end

return m.serialize
