local assets = require('utils.assets')
local tex = assets.img('tex.png')
local q = assets.quad('dark_dust')

local psystem = love.graphics.newParticleSystem(tex, 10)
psystem:setParticleLifetime(0.5)
psystem:setEmissionRate(0)
psystem:setSizeVariation(0.1)
psystem:setSizes(0.9, 0.1)
psystem:setSpeed(200, 160)
psystem:setSpread(math.pi*2)
psystem:setLinearDamping(18,22)
psystem:setTexture(tex)
psystem:setQuads(q)
psystem:setOffset(1, 2) -- needed when dealing with quads (?)
-- psystem:setLinearAcceleration(-50, -20, 50, 20)
psystem:setColors(80,80,80,250, 80,80,80,250) -- fade
psystem:setAreaSpread('uniform', 10, 8)

local explosion_particles = {
  new = function()
    local p =  psystem:clone()
    p:start()
    return p
  end
}

return explosion_particles
