local assets = require('utils.assets')
local tex = assets.img('tex.png')
local qn = assets.quadsGroup('player_run')[1]
local qf = assets.quad('player_flipped_particle')

local player_dash_psystem = love.graphics.newParticleSystem(tex, 16)
player_dash_psystem:setParticleLifetime(0.2)
player_dash_psystem:setEmissionRate(0)
player_dash_psystem:setSizes(1, 0.4)
-- player_dash_psystem:setRotation(-math.pi, -math.pi)
player_dash_psystem:setTexture(tex)
-- player_dash_psystem:setQuads(qs[1])
player_dash_psystem:setQuads(qn)
player_dash_psystem:setOffset(8, 16) -- needed when dealing with quads
player_dash_psystem:setColors(255, 255, 255, 50, 255, 255, 255, 10) -- Fade to transparency.
-- player_dash_psystem:setAreaSpread('uniform', 2, 0)

local player_dash = {
  new = function()
    local p =  player_dash_psystem:clone()
    p:start()
    return p
  end,
  setFlip = function(p, dir)
    p:setQuads(dir < 0 and qf or qn)
  end
}

return player_dash
