local assets = require('utils.assets')
local tex = assets.img('tex.png')
local q = assets.quad('dust')

local psystem = love.graphics.newParticleSystem(tex, 64)
psystem:setParticleLifetime(0.3)
psystem:setEmissionRate(0)
psystem:setSizeVariation(0.1)
psystem:setSizes(0.3, 0.1)
psystem:setSpeed(40, 50)
psystem:setSpread(math.pi*2)
psystem:setLinearDamping(5,12)
psystem:setTexture(tex)
psystem:setQuads(q)
psystem:setOffset(1, 2) -- needed when dealing with quads (?)
-- psystem:setLinearAcceleration(-50, -20, 50, 20)
psystem:setColors(255, 255, 255, 50, 255, 255, 255, 30) -- fade
psystem:setAreaSpread('uniform', 10, 8)

local player_dust = {
  new = function()
    local p =  psystem:clone()
    p:start()
    return p
  end,

  stomp = function(p, x, y)
    p:moveTo(x, y)
    p:setColors(255, 255, 255, 80, 255, 255, 255, 50)
    p:setAreaSpread('uniform', 10, 8)
    p:setSpeed(40, 50)
    p:setSizes(0.3, 0.1)
    p:emit(16)
  end,

  jump = function(p, x, y)
    p:moveTo(x, y+1)
    p:setColors(255, 255, 255, 50, 255, 255, 255, 30)
    p:setAreaSpread('uniform', 4, 3)
    p:setSpeed(20, 30)
    p:setSizes(0.2, 0.0)
    p:emit(5)
  end,

  run = function(p, x, y)
    p:moveTo(x, y)
    p:setColors(255, 255, 255, 50, 255, 255, 255, 30)
    p:setAreaSpread('uniform', 4, 3)
    p:setSpeed(10, 20)
    p:setSizes(0.2, 0.0)
    p:emit(4)
  end,

  rescue_jump = function(p, x, y)
    p:moveTo(x, y)
    p:setColors(255, 255, 255, 50, 255, 255, 255, 30)
    p:setAreaSpread('uniform', 4, 3)
    p:setSpeed(70, 80)
    p:setSizes(0.3, 0.0)
    p:emit(8)
  end
}

player_dust.fall = player_dust.jump -- alias

return player_dust
