local assets = require('utils.assets')
local tex = assets.img('tex.png')
local q = assets.quad('dust')

local dust_psystem = love.graphics.newParticleSystem(tex, 5)
dust_psystem:setParticleLifetime(0.8, 0.9) -- Particles live at least 2s and at most 5s.
dust_psystem:setEmissionRate(0)

dust_psystem:setSizes(0.3, 0.05)
dust_psystem:setTexture(tex)
dust_psystem:setQuads(q)
dust_psystem:setOffset(1, 2) -- needed when dealing with quads
dust_psystem:setLinearAcceleration(-30, -30, 30, 30)
dust_psystem:setColors(255, 255, 255, 30, 255, 255, 255, 0) -- Fade to transparency.
dust_psystem:setAreaSpread('normal', 8, 8)

local dust = {
  new = function()
    local p =  dust_psystem:clone()
    p:start()
    return p
  end
}

return dust
