local assets = require('utils.assets')
local input = require('input')

local game
local tutorial_state = {}

local function _drawImgInTheMiddle(img_name)
  local img = assets.img(img_name)
  local img_w, img_h = img:getDimensions()
  local w, h = game.getDimensions()

  love.graphics.draw(img, w/2, h/2, 0, 1, 1, img_w/2, img_h/2)
end

function tutorial_state.setup(_game)
  game = _game
end

function tutorial_state.init()
end

function tutorial_state.draw()
  _drawImgInTheMiddle('tutorial.png')
end

function tutorial_state.update(dt)
  if input.anyHit(1) then
    game.setState('join_state')
  end
end

return tutorial_state
