local assets = {}

local _imgs = {}

function assets.img(name)
  if not _imgs[name] then
    _imgs[name] = love.graphics.newImage('assets/' .. name)
    _imgs[name]:setFilter('nearest', 'nearest')
  end

  return _imgs[name]
end

local _qdata = require('assets.quads')
local nQ = love.graphics.newQuad

function assets.quad(key, frame)
  local qd
  if frame then
    qd = _qdata[key].qs[frame]
  else
    qd = _qdata[key].q
  end

  if not qd.quad then
    qd.quad = nQ(qd.x, qd.y, qd.w, qd.h, _qdata.TEXTURE_SIZE, _qdata.TEXTURE_SIZE)
  end
  return qd.quad
end

-- just pass to anim8 as a grid
local _quads_group = {}
function assets.quadsGroup(key)
  if not _quads_group[key] then
    local t = {}
    for i=1,#_qdata[key].qs do
      t[#t+1] = assets.quad(key, i)
    end
    _quads_group[key] = t
  end
  return _quads_group[key]
end

function assets.draw(qname, ...)
  love.graphics.draw(assets.img('tex.png'), assets.quad(qname), ...)
end

function assets.drawFrame(qname, f, ...)
  love.graphics.draw(assets.img('tex.png'), assets.quad(qname, f), ...)
end

return assets
