local input = require('input')
local signal = require('lib.signal')

local bots = {
  list = {}
}

function bots.setup(_game, _map)
  game = _game
  map = _map
end

function bots.add()
  if #bots.list >= 4 then return end
  local id = #bots.list + 1
  bots.list[id] = { id = 'bot_' .. id }
end

function bots.clear()
  bots.list = {}
end

-- function bots.join(b)
--   local player_id = input.assign('next', b.id) -- todo
-- end

function bots.draw()
  if #bots.list > 0 then
    love.graphics.printf('bots: ' .. #bots.list, -10, 10, love.graphics.getWidth(), 'right')
    -- love.graphics.printf(text (string), x (number), y (number), limit (number), align (AlignMode), r (number), sx (number), sy (number), ox (number), oy (number), kx (number), ky (number))
  end
end

local function botUpdate(b, dt)
  if game.curr_state_name == 'join_state' then
    if game.curr_state.t > 1 and game.curr_state.getCount() > 0 then
      input.setAssignmentReq(b.id, true)
      local pid = input.deviceToPlayerId(b.id)
      if pid then
        input.set(pid, 'jump', true)
      end
    end
  end

  if game.curr_state_name == 'play' then
    -- TODO
    -- if not b.player then
    --   b.player = game.map.players[input.deviceToPlayerId(b.id)]
    --
    -- else
    --   b.player:setDir(love.math.random()-0.5, love.math.random()-0.5)
    --
    --   if b.player.dir_x > 1 then
    --     input.set(input.deviceToPlayerId(b.id), 'right', true)
    --   else
    --     input.set(input.deviceToPlayerId(b.id), 'left', true)
    --   end
    --
    --   if b.player.dir_y > 1 then
    --     input.set(input.deviceToPlayerId(b.id), 'down', true)
    --   else
    --     input.set(input.deviceToPlayerId(b.id), 'right', true)
    --   end
    --
    -- end


  else
    b.player = nil
  end

  if game.curr_state_name == 'show_points' then

  end
end

function bots.update(dt)
  for _, b in ipairs(bots.list) do
    botUpdate(b, dt)
  end
end


return bots
