local filters = {}

function filters.null(item)
end

function filters.querySafeTile(item)
  return item.is_tile and not item.is_falling and not item.till_fall_t
end

function filters.queryPointTile(item)
  return item.is_tile and item.color
end

function filters.queryBomb(item)
  return item.is_bomb
end

function filters.queryBox(item)
  return item.is_box
end

function filters.queryTile(item)
  return item.is_tile
end

function filters.queryBombOrBox(item)
  return item.is_bomb or item.is_box
end

function filters.queryPlayer(item)
  return item.is_player
end

filters.queryPlayerExceptId = {
  function(item) return item.is_player and item.id ~= 1 end,
  function(item) return item.is_player and item.id ~= 2 end,
  function(item) return item.is_player and item.id ~= 3 end,
  function(item) return item.is_player and item.id ~= 4 end,
}

function filters.jumpStd(self, other)
  return nil
end

function filters.moveBomb(self, other)
  if other.is_box then
    if other:canTouchBomb() then
      return 'cross'
    else
      return nil
    end
  end
end

function filters.moveStd(self, other)
  if other.is_obstacle then return 'slide' end
  if other.is_player then return 'cross' end
  if other.is_pickable then return 'cross' end
  if other.is_bomb then return 'cross' end -- bomb might be nonpickable in some states
  return nil
end



return filters
