local signal = require('lib.signal')

local FLASH_TIME = 1.0
local FADE_TIME = 0.333

local flash = {
  t = FLASH_TIME + 10,
  fade_t = FADE_TIME + 10
}

local color = 'white'

function flash.setup()
  signal.register('flash', function()
    flash.t = 0
  end)
end

local function drawFlash(t)
  if t > FLASH_TIME*2 then return end

  local alpha =
    1 - (math.abs(((t) / FLASH_TIME) - 0.5) * 2)

  if alpha < 0 then return end

  love.graphics.setColor(255, 255, 255, alpha * 255)
  local e5 = 10000
  love.graphics.rectangle('fill', -e5, -e5, e5*2, e5*2)
end

function flash.draw()
  drawFlash(flash.t)
end

function flash.update(dt)
  flash.t = flash.t + dt
end

return flash
